<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLMutationMessage Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classMutationMessage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLMutationMessage Class Reference<div class="ingroups"><a class="el" href="group__mutation__engine.html">Mutation Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core mutation Massage container class.  
 <a href="classMutationMessage.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglMutationMessage_8hpp_source.html">tiglMutationMessage.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2531f613fca0307804d1a4bf45e92cf5"><td class="memItemLeft" align="right" valign="top">MUTATION_MESSAGE_CODE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a2531f613fca0307804d1a4bf45e92cf5">getMessageCode</a> ()</td></tr>
<tr class="memdesc:a2531f613fca0307804d1a4bf45e92cf5"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the mutation message code  <a href="#a2531f613fca0307804d1a4bf45e92cf5">More...</a><br /></td></tr>
<tr class="separator:a2531f613fca0307804d1a4bf45e92cf5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5e6c1267025dd31a9a1b451773e5c12"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#af5e6c1267025dd31a9a1b451773e5c12">getSizeInBytes</a> ()</td></tr>
<tr class="memdesc:af5e6c1267025dd31a9a1b451773e5c12"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading the overall message body  <a href="#af5e6c1267025dd31a9a1b451773e5c12">More...</a><br /></td></tr>
<tr class="separator:af5e6c1267025dd31a9a1b451773e5c12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f310d29543acd44b4642e2bc7e384c3"><td class="memItemLeft" align="right" valign="top">int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a2f310d29543acd44b4642e2bc7e384c3">getDstDev</a> ()</td></tr>
<tr class="memdesc:a2f310d29543acd44b4642e2bc7e384c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading teh destination device  <a href="#a2f310d29543acd44b4642e2bc7e384c3">More...</a><br /></td></tr>
<tr class="separator:a2f310d29543acd44b4642e2bc7e384c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8650ccd700d60a94b9ebde4fb1ad37aa"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a8650ccd700d60a94b9ebde4fb1ad37aa"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a8650ccd700d60a94b9ebde4fb1ad37aa">getDstVertex</a> (ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a8650ccd700d60a94b9ebde4fb1ad37aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns destination vertex  <a href="#a8650ccd700d60a94b9ebde4fb1ad37aa">More...</a><br /></td></tr>
<tr class="separator:a8650ccd700d60a94b9ebde4fb1ad37aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec21a534f9e4e76e7b11c8cd305e4630"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#aec21a534f9e4e76e7b11c8cd305e4630">pack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:aec21a534f9e4e76e7b11c8cd305e4630"><td class="mdescLeft">&#160;</td><td class="mdescRight">packing the mutation message into bytes / the packed message contains the message code and the message body  <a href="#aec21a534f9e4e76e7b11c8cd305e4630">More...</a><br /></td></tr>
<tr class="separator:aec21a534f9e4e76e7b11c8cd305e4630"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59c0c868cb14b3705c865ae48fba7999"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a59c0c868cb14b3705c865ae48fba7999">unpack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:a59c0c868cb14b3705c865ae48fba7999"><td class="mdescLeft">&#160;</td><td class="mdescRight">unpacking a mutation message to the object fields  <a href="#a59c0c868cb14b3705c865ae48fba7999">More...</a><br /></td></tr>
<tr class="separator:a59c0c868cb14b3705c865ae48fba7999"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b4b4ba804a27a446972d3513022907a"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a4b4b4ba804a27a446972d3513022907a"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a4b4b4ba804a27a446972d3513022907a">readVertexMessage</a> (<a class="el" href="classVertexBase.html">CVertex</a> *vertex)</td></tr>
<tr class="memdesc:a4b4b4ba804a27a446972d3513022907a"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for reading add/migrate vertex messages  <a href="#a4b4b4ba804a27a446972d3513022907a">More...</a><br /></td></tr>
<tr class="separator:a4b4b4ba804a27a446972d3513022907a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa04ba5fb38fa4df4fdf43b4040b5fc8a"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:aa04ba5fb38fa4df4fdf43b4040b5fc8a"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#aa04ba5fb38fa4df4fdf43b4040b5fc8a">readSimpleVertexMessage</a> (ID_TYPE *id)</td></tr>
<tr class="memdesc:aa04ba5fb38fa4df4fdf43b4040b5fc8a"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for reading add/migrate vertex messages. It  <a href="#aa04ba5fb38fa4df4fdf43b4040b5fc8a">More...</a><br /></td></tr>
<tr class="separator:aa04ba5fb38fa4df4fdf43b4040b5fc8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23a946dbc9eabac6e14e2228150cc116"><td class="memTemplParams" colspan="2">template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a23a946dbc9eabac6e14e2228150cc116"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a23a946dbc9eabac6e14e2228150cc116">readEdgeMessage</a> (<a class="el" href="classEdgeBase.html">EDGE_TYPE</a> *edge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a23a946dbc9eabac6e14e2228150cc116"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for reading add edge messages.  <a href="#a23a946dbc9eabac6e14e2228150cc116">More...</a><br /></td></tr>
<tr class="separator:a23a946dbc9eabac6e14e2228150cc116"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6ecec92a031c4076a0ae9467b3a8edf"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:ad6ecec92a031c4076a0ae9467b3a8edf"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#ad6ecec92a031c4076a0ae9467b3a8edf">readSimpleEdgeMessage</a> (ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:ad6ecec92a031c4076a0ae9467b3a8edf"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for reading remove edge messages. It has two outupts  <a href="#ad6ecec92a031c4076a0ae9467b3a8edf">More...</a><br /></td></tr>
<tr class="separator:ad6ecec92a031c4076a0ae9467b3a8edf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3753e80667cac7b685dc0f7cabd1dbfe"><td class="memTemplParams" colspan="2">template&lt;typename EdgeType , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a3753e80667cac7b685dc0f7cabd1dbfe"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a3753e80667cac7b685dc0f7cabd1dbfe">writeEdgeMessage</a> (MUTATION_MESSAGE_CODE code, EdgeType *edge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a3753e80667cac7b685dc0f7cabd1dbfe"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for writing ADD edge messages.  <a href="#a3753e80667cac7b685dc0f7cabd1dbfe">More...</a><br /></td></tr>
<tr class="separator:a3753e80667cac7b685dc0f7cabd1dbfe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9bd1dfc3820f64a6ae1fe36b2ec4e71"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:aa9bd1dfc3820f64a6ae1fe36b2ec4e71"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#aa9bd1dfc3820f64a6ae1fe36b2ec4e71">writeSimpleEdgeMessage</a> (MUTATION_MESSAGE_CODE code, ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:aa9bd1dfc3820f64a6ae1fe36b2ec4e71"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for writing REMOVE edge messages.  <a href="#aa9bd1dfc3820f64a6ae1fe36b2ec4e71">More...</a><br /></td></tr>
<tr class="separator:aa9bd1dfc3820f64a6ae1fe36b2ec4e71"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab86d9bff2b1b1f4e0e12f83144abeab6"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:ab86d9bff2b1b1f4e0e12f83144abeab6"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#ab86d9bff2b1b1f4e0e12f83144abeab6">writeVertexMessage</a> (MUTATION_MESSAGE_CODE code, <a class="el" href="classVertexBase.html">CVertex</a> *vertex)</td></tr>
<tr class="memdesc:ab86d9bff2b1b1f4e0e12f83144abeab6"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for writing ADD/MIGRATE vertex messages.  <a href="#ab86d9bff2b1b1f4e0e12f83144abeab6">More...</a><br /></td></tr>
<tr class="separator:ab86d9bff2b1b1f4e0e12f83144abeab6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b920f713662323833989c5a4b2dc153"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a3b920f713662323833989c5a4b2dc153"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a3b920f713662323833989c5a4b2dc153">writeSimpleVertexMessage</a> (MUTATION_MESSAGE_CODE code, ID_TYPE *id)</td></tr>
<tr class="memdesc:a3b920f713662323833989c5a4b2dc153"><td class="mdescLeft">&#160;</td><td class="mdescRight">procedure for writing add empty/remove vertex messages.  <a href="#a3b920f713662323833989c5a4b2dc153">More...</a><br /></td></tr>
<tr class="separator:a3b920f713662323833989c5a4b2dc153"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:ad8c6290bc3d59488f57f341d04d356d8"><td class="memTemplParams" colspan="2">template&lt;typename EdgeType , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:ad8c6290bc3d59488f57f341d04d356d8"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#ad8c6290bc3d59488f57f341d04d356d8">prepareAddEdgeMessage</a> (EdgeType *pEdge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:ad8c6290bc3d59488f57f341d04d356d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">preparing the ADD_OUT/IN_EDGE mutation message  <a href="#ad8c6290bc3d59488f57f341d04d356d8">More...</a><br /></td></tr>
<tr class="separator:ad8c6290bc3d59488f57f341d04d356d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b6e1b5ce4c29e252a839bb7d28b2bc5"><td class="memTemplParams" colspan="2">template&lt;typename EdgeType , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a1b6e1b5ce4c29e252a839bb7d28b2bc5"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a1b6e1b5ce4c29e252a839bb7d28b2bc5">readAddEdgeMessage</a> (EdgeType *pEdge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a1b6e1b5ce4c29e252a839bb7d28b2bc5"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading the ADD/REMOVE_EDGE mutation message  <a href="#a1b6e1b5ce4c29e252a839bb7d28b2bc5">More...</a><br /></td></tr>
<tr class="separator:a1b6e1b5ce4c29e252a839bb7d28b2bc5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab06823de2c4142ff408754e08f4710d8"><td class="memTemplParams" colspan="2">template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:ab06823de2c4142ff408754e08f4710d8"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#ab06823de2c4142ff408754e08f4710d8">prepareRemoveEdgeMessage</a> (<a class="el" href="classEdgeBase.html">EDGE_TYPE</a> *edge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:ab06823de2c4142ff408754e08f4710d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">preparing the REMOVE_OUT/IN_EDGE mutation message  <a href="#ab06823de2c4142ff408754e08f4710d8">More...</a><br /></td></tr>
<tr class="separator:ab06823de2c4142ff408754e08f4710d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a32c9927704e480a550345178a3ba3c90"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a32c9927704e480a550345178a3ba3c90"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a32c9927704e480a550345178a3ba3c90">prepareRemoveEdgeMessage</a> (ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a32c9927704e480a550345178a3ba3c90"><td class="mdescLeft">&#160;</td><td class="mdescRight">preparing the REMOVE_OUT/IN_EDGE mutation message  <a href="#a32c9927704e480a550345178a3ba3c90">More...</a><br /></td></tr>
<tr class="separator:a32c9927704e480a550345178a3ba3c90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a588b2459d4dd50217a6451af8802e88d"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a588b2459d4dd50217a6451af8802e88d"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a588b2459d4dd50217a6451af8802e88d">readRemoveEdgeMessage</a> (ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a588b2459d4dd50217a6451af8802e88d"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading the ADD/REMOVE_EDGE mutation message  <a href="#a588b2459d4dd50217a6451af8802e88d">More...</a><br /></td></tr>
<tr class="separator:a588b2459d4dd50217a6451af8802e88d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a38bab73f34940fac16c6d094576cdaad"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a38bab73f34940fac16c6d094576cdaad"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a38bab73f34940fac16c6d094576cdaad">prepareEmptyVertexMessage</a> (ID_TYPE *vertexId)</td></tr>
<tr class="memdesc:a38bab73f34940fac16c6d094576cdaad"><td class="mdescLeft">&#160;</td><td class="mdescRight">preparing the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message  <a href="#a38bab73f34940fac16c6d094576cdaad">More...</a><br /></td></tr>
<tr class="separator:a38bab73f34940fac16c6d094576cdaad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbd3fa9e6726c2f833d1713a985affc4"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:abbd3fa9e6726c2f833d1713a985affc4"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#abbd3fa9e6726c2f833d1713a985affc4">readEmptyVertexMessage</a> (ID_TYPE *vertexId)</td></tr>
<tr class="memdesc:abbd3fa9e6726c2f833d1713a985affc4"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message  <a href="#abbd3fa9e6726c2f833d1713a985affc4">More...</a><br /></td></tr>
<tr class="separator:abbd3fa9e6726c2f833d1713a985affc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8383fd40ae0a2a444b94c9851dbae8d9"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a8383fd40ae0a2a444b94c9851dbae8d9"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a8383fd40ae0a2a444b94c9851dbae8d9">prepareAddVertexMessage</a> (<a class="el" href="classVertexBase.html">CVertex</a> *vertex)</td></tr>
<tr class="memdesc:a8383fd40ae0a2a444b94c9851dbae8d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">preparing the ADD_VERTEX message  <a href="#a8383fd40ae0a2a444b94c9851dbae8d9">More...</a><br /></td></tr>
<tr class="separator:a8383fd40ae0a2a444b94c9851dbae8d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85a9603c0995c954654db90b6e3c753d"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a85a9603c0995c954654db90b6e3c753d"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a85a9603c0995c954654db90b6e3c753d">readAddVertexMessage</a> (<a class="el" href="classVertexBase.html">CVertex</a> *pVertex)</td></tr>
<tr class="memdesc:a85a9603c0995c954654db90b6e3c753d"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading the ADD_VERTEX  <a href="#a85a9603c0995c954654db90b6e3c753d">More...</a><br /></td></tr>
<tr class="separator:a85a9603c0995c954654db90b6e3c753d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:acdce3bb6d07d5b7fe2895c3858137a14"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acdce3bb6d07d5b7fe2895c3858137a14"></a>
MUTATION_MESSAGE_CODE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#acdce3bb6d07d5b7fe2895c3858137a14">messageCode</a></td></tr>
<tr class="memdesc:acdce3bb6d07d5b7fe2895c3858137a14"><td class="mdescLeft">&#160;</td><td class="mdescRight">code of the mutation message <br /></td></tr>
<tr class="separator:acdce3bb6d07d5b7fe2895c3858137a14"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75836599fbe19b77ad02531021b1e6ab"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a75836599fbe19b77ad02531021b1e6ab"></a>
vector&lt; uint8_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a75836599fbe19b77ad02531021b1e6ab">messageBody</a></td></tr>
<tr class="memdesc:a75836599fbe19b77ad02531021b1e6ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">message body in bytes <br /></td></tr>
<tr class="separator:a75836599fbe19b77ad02531021b1e6ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7523a146cee179e0f116f8e41d1f3c80"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7523a146cee179e0f116f8e41d1f3c80"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMutationMessage.html#a7523a146cee179e0f116f8e41d1f3c80">otherDevice</a></td></tr>
<tr class="memdesc:a7523a146cee179e0f116f8e41d1f3c80"><td class="mdescLeft">&#160;</td><td class="mdescRight">the destination device <br /></td></tr>
<tr class="separator:a7523a146cee179e0f116f8e41d1f3c80"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Core mutation Massage container class. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a2f310d29543acd44b4642e2bc7e384c3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int_fast32_t TIGLMutationMessage::getDstDev </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading teh destination device </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="a8650ccd700d60a94b9ebde4fb1ad37aa"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::getDstVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>returns destination vertex </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="a2531f613fca0307804d1a4bf45e92cf5"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">MUTATION_MESSAGE_CODE TIGLMutationMessage::getMessageCode </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>returns the mutation message code </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="af5e6c1267025dd31a9a1b451773e5c12"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::getSizeInBytes </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading the overall message body </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="aec21a534f9e4e76e7b11c8cd305e4630"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::pack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>packing the mutation message into bytes / the packed message contains the message code and the message body </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>output buffer for packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="ad8c6290bc3d59488f57f341d04d356d8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EdgeType , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareAddEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">EdgeType *&#160;</td>
          <td class="paramname"><em>pEdge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>preparing the ADD_OUT/IN_EDGE mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pEdge</td><td>pointer to the edge to be added </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the ID of the target vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="a8383fd40ae0a2a444b94c9851dbae8d9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareAddVertexMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>vertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>preparing the ADD_VERTEX message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertex</td><td>pointer to the vertex object </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the size of the message body </dd></dl>

</div>
</div>
<a class="anchor" id="a38bab73f34940fac16c6d094576cdaad"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareEmptyVertexMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>vertexId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>preparing the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexId</td><td>vertex ID </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="ab06823de2c4142ff408754e08f4710d8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareRemoveEdgeMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classEdgeBase.html">EDGE_TYPE</a> *&#160;</td>
          <td class="paramname"><em>edge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>preparing the REMOVE_OUT/IN_EDGE mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">edge</td><td>pointer to the the edge object </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the target vertex where we remove this edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="a32c9927704e480a550345178a3ba3c90"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareRemoveEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>preparing the REMOVE_OUT/IN_EDGE mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbrVertex</td><td>pointer to the other side of the vertex </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the target vertex where we remove this edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="a1b6e1b5ce4c29e252a839bb7d28b2bc5"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EdgeType , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readAddEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">EdgeType *&#160;</td>
          <td class="paramname"><em>pEdge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading the ADD/REMOVE_EDGE mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pEdge</td><td>pointer to the read buffer of the edge </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the ID of targe tvertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="a85a9603c0995c954654db90b6e3c753d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readAddVertexMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>pVertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading the ADD_VERTEX </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pVertex</td><td>pointer to the empty vertex object that's filled inside the function </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a23a946dbc9eabac6e14e2228150cc116"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readEdgeMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classEdgeBase.html">EDGE_TYPE</a> *&#160;</td>
          <td class="paramname"><em>edge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for reading add edge messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">edge</td><td>pointer to the edge object, </td></tr>
    <tr><td class="paramname">targetVertex</td><td>and the target vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="abbd3fa9e6726c2f833d1713a985affc4"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readEmptyVertexMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>vertexId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexId</td><td>output vertex ID </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="a588b2459d4dd50217a6451af8802e88d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readRemoveEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading the ADD/REMOVE_EDGE mutation message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbrVertex</td><td>pointer to the other side of the vertex </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the target vertex where we remove this edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="ad6ecec92a031c4076a0ae9467b3a8edf"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readSimpleEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for reading remove edge messages. It has two outupts </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbrVertex</td><td>pointer to other side of the edge, </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the vertex ID of the vertex from which the edge is removed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="aa04ba5fb38fa4df4fdf43b4040b5fc8a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readSimpleVertexMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for reading add/migrate vertex messages. It </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>pointer the vertex ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4b4b4ba804a27a446972d3513022907a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readVertexMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>vertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for reading add/migrate vertex messages </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertex</td><td>pointer to the vertex object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a59c0c868cb14b3705c865ae48fba7999"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::unpack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>unpacking a mutation message to the object fields </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>input buffer for the packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size (in bytes) of the unpacked message </dd></dl>

</div>
</div>
<a class="anchor" id="a3753e80667cac7b685dc0f7cabd1dbfe"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EdgeType , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EdgeType *&#160;</td>
          <td class="paramname"><em>edge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for writing ADD edge messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either ADD_OUT_EDGE or ADD_IN_EDGE </td></tr>
    <tr><td class="paramname">edge</td><td>pointer to the edge object </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the vertex ID of the vertex to which the edge is added </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa9bd1dfc3820f64a6ae1fe36b2ec4e71"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeSimpleEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for writing REMOVE edge messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either REMOVE_OUT_EDGE or REMOVE_IN_EDGE </td></tr>
    <tr><td class="paramname">nbrVertex</td><td>pointer to the vertex ID of the other side of the edge </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the vertex ID of the vertex to which the edge is added </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3b920f713662323833989c5a4b2dc153"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeSimpleVertexMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for writing add empty/remove vertex messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either ADD_EMPTY_VERTEX or REMOVE_VERTEX </td></tr>
    <tr><td class="paramname">id</td><td>pointer to the vertex id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab86d9bff2b1b1f4e0e12f83144abeab6"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeVertexMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>vertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>procedure for writing ADD/MIGRATE vertex messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either ADD_VERTEX or MIGRATE_VERTEX </td></tr>
    <tr><td class="paramname">vertex</td><td>pointer to the vertex object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/mohamed/code/tigl/src/common/mutation/<a class="el" href="tiglMutationMessage_8hpp_source.html">tiglMutationMessage.hpp</a></li>
<li>/home/mohamed/code/tigl/src/common/mutation/<a class="el" href="tiglMutationMessageImplementation_8hpp_source.html">tiglMutationMessageImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:17:02 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
